=== deps/http_parser/CMakeLists.txt ===
include_directories (.)
add_library (http_parser http_parser.c)
