=== debian/changelog ===
nodejs (0.4.9-1ubuntu3) oneiric; urgency=low

  * 2007_remove_internet_test.patch: updated to remove more one test that needs
    internet connections (test-net-connect-timeout)

 -- Fabrice Coutadeur <fabricesp@ubuntu.com>  Thu, 30 Jun 2011 19:48:43 +0200

nodejs (0.4.9-1ubuntu2) oneiric; urgency=low

  * debian/patches/2007_remove_internet_test.patch: updated to remove
    test-regress-GH-819 test, as it requires internet connection

 -- Fabrice Coutadeur <fabricesp@ubuntu.com>  Thu, 30 Jun 2011 07:42:26 +0200

nodejs (0.4.9-1ubuntu1) oneiric; urgency=low

  * Merge from Debian unstable (LP: #786428). Remaining changes:
    - debian/patches/2007_remove_internet_test.patch: Remove test which requires
      internet connection

 -- Fabrice Coutadeur <fabricesp@ubuntu.com>  Thu, 30 Jun 2011 07:03:44 +0200

nodejs (0.4.9-1) unstable; urgency=low

  * New upstream release
  * Refresh debian/patches,
    remove 1001_no_ssl_v2.patch, applied upstream.
  * deps/http_parser.c based on expat-licensed work of Igor Sysoev.

 -- Jérémy Lal <kapouer@melix.org>  Wed, 29 Jun 2011 16:46:47 +0200

nodejs (0.4.8-1) unstable; urgency=low

  * New upstream release,
    Closes: bug#628148.
  * Depends on libv8 3.1.8.22
  * Refresh debian/patches 

 -- Jérémy Lal <kapouer@melix.org>  Sun, 26 Jun 2011 23:08:01 +0200

nodejs (0.4.7-1) unstable; urgency=low

  * New upstream release
  * Bump policy compliance to standards-version 3.9.2.
  * debian/watch : remove call to uupdate, it is annoying since
    updates are done with git-import-orig. 

 -- Jérémy Lal <kapouer@melix.org>  Sat, 23 Apr 2011 18:42:42 +0200

nodejs (0.4.6-2) unstable; urgency=low

  * Expect some tests to fail when run without network.
    Closes: bug#623374.

 -- Jérémy Lal <kapouer@melix.org>  Tue, 19 Apr 2011 22:17:37 +0200

nodejs (0.4.6-1) unstable; urgency=low

  * New upstream release

  [ Jérémy Lal ]
  * Unfuzz patches.
  * Update debian/copyright, now copyright Joyent.
  * Drop SSL2 methods, see #589706.
    Closes: bug#622065.
  * Disable multicast test: Too dependent on network config.
  * Allow Debian-Maintainer uploads.

  [ Jonas Smedegaard ]
  * Update copyright file:
    + Fix relabel OpenBSD license as OpenBSD~Lucent: Disclaimer is
      derived.
    + Fix comma-delimit files, and (while at it) newline-delimit them
      for improved readability.
    + Compact and extend copyright years.
  * Enable copyright-check.
    Build-depend on devscripts.
  * Add copyright hints.

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 17 Apr 2011 05:05:30 +0200

nodejs (0.4.2-1) experimental; urgency=low

  * New upstream release

  [ Jérémy Lal ]
  * Enable regression tests, without failing when targeted experimental.
  * Unfuzz patches.
  * Tighten build-dependency on libev-dev, to match new upstream source.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 12 Mar 2011 10:45:08 +0100

nodejs (0.2.6-5) unstable; urgency=low

  [ Jonas Smedegaard ]
  * Update team-maintainance:
    + Set Debian Javascript Maintainers as maintainer.
    + Set Jérémy Lal, Dave Beckett and myself as uploaders.
  * Bump policy compliance to standards-version 3.9.2.
  * Recompile against newer libv8.
    Closes: bug#622623. Thanks to Adrian Knoth.
  * Unfuzz patches.

  [ Jérémy Lal ]
  * Update git-buildpackage config : add commented lines explaining
    layout.
  * Allow Debian-Maintainer uploads.
  * Add patch 1001 to disable ssl2 methods.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 15 Apr 2011 23:33:09 +0200
