=== debian/watch ===
version=3
http://nodejs.org/dist/node-v(\d+\.[02468]\..*).tar.gz
